' 
'    Programmname: ID3DOS v1.1
'        Compiler: PowerBASIC 3.20
'       Copyright: Public Domain
'           Autor: Thiemo Mttig, Hauptstr. 11, D-02627 Hochkirch
' letzte nderung: 23.08.1999
' 

'$compile exe "id3dos.exe"
$cpu 80386						'luft ab 386er
$float npx						'mit Coprozessor
$string 1
$sound 1
$com 0
$lib all off						'keine Bibliotheken
$error all off						'keine Fehlertests
$event off						'keine Ereignisse
defint a-z						'alles Integer

?"ID3DOS v1.1 von Mad/OS"
c$=rtrim$(ltrim$(ucase$(command$)))			'Parameter auswerten
if tally(c$,".")=0 then
  c$=c$+".MP3"
elseif right$(c$,3)<>"MP3" then
  ?"Dieses Programm kann nur Dateien im Format MP3 bearbeiten!"
  end
end if
if len(dir$(c$))=0 then
  ?"Als Parameter mu eine MP3-Datei angegeben werden!"
  end
end if

if (attrib(c$) and 1) then				'Read Only prfen
  ?"Die Datei ";c$;" ist schreibgeschtzt!"
  ?"Soll der Schreibschutz entfernt werden? <J/n>"
  i$=ucase$(input$(1))					'nachfragen
  if i$="N" or i$=chr$(27) then close: end
  attrib c$,0						'alle Attribute weg
end if

open c$ for binary as 1					'die Datei ffnen
GetFileDate Datum??, Zeit??
seek 1,lof(1)-128
get$ 1,3,Tag$						'Kennung "TAG" suchen
if Tag$="TAG" then
  ?"Die Datei ";c$;" enthlt bereits einen ID3-Tag."
  ?"Soll dieser gelscht werden? <j/N>"
  if ucase$(input$(1))="J" then
    seek 1,lof(1)-128: put$ 1,""			'ID3-Tag lschen
    ?"ID3-Tag gelscht..."
    SetFileDate Datum??, Zeit??
    close: end
  end if
  get$ 1,30,Titel$: get$ 1,30,Interpret$		'Inhalte auslesen
  get$ 1,30,Cd$: get$ 1,4,Jahr$
  get$ 1,30,Kommentar$: get 1,lof(1)-1,Genre?
  seek 1,lof(1)-128					'zum Anfang springen
else
  ?"Die Datei ";c$;" enthlt noch keinen ID3-Tag..."
  Genre?=255						'kein Genre
  seek 1,lof(1)						'Sprung ans Dateiende
end if

Eingabe "Titel des Stcks", 30, Titel$			'Eintrge editieren
Eingabe "Name des Knstlers", 30, Interpret$
Eingabe "Titel der CD", 30, Cd$
Eingabe "Jahr der Verffentlichung", 4, Jahr$
Eingabe "Kommentar", 30, Kommentar$

?"Genre: [                 ] Schnellsuche mit den Buchstabentasten..."
for i=3 to 10: ?: next: z=csrlin-9
if Genre?=255 then Wahl=-1 else Wahl=Genre?		'kein Genre?
Anzahl=147: dim g(-1:Anzahl) as string			'dimensionieren
for i=-1 to Anzahl
  read g(i): g(i)=g(i)+space$(17-len(g(i)))		'DATA's auslesen
next

do
  for i=0 to 9
    locate z+i,9
    if i+Wahl>Anzahl then ?"                 "; else ? g(i+Wahl);
  next
  locate z,28
  if Wahl>43 and Kompa=0 then
    ?"Wird von lteren Playern nicht angezeigt!";: Kompa=1
  elseif Wahl<44 and Kompa=1 then
    ?"                                         ";: Kompa=0
  end if

  i$="": while i$="": i$=inkey$: wend
  select case i$
    case chr$(0,72): if Wahl>-1 then decr Wahl		'Pfeil hoch
    case chr$(0,80): if Wahl<Anzahl then incr Wahl	'Pfeil runter
    case chr$(0,73)					'Bild hoch
      if Wahl>10 then decr Wahl,10 else Wahl=-1
    case chr$(0,81)					'Bild runter
      if Wahl<Anzahl-10 then incr Wahl,10 else Wahl=Anzahl
    case chr$(0,71), chr$(0,83): Wahl=-1		'Pos1, Entf
    case chr$(0,79): Wahl=Anzahl			'Ende
    case chr$(13)					'Enter
      if Wahl=-1 then Genre?=255 else Genre?=Wahl
      exit loop
    case chr$(27): exit loop				'Esc
    case "a" to "z", "A" to "Z"				'Zeichentasten
      for i=1 to Anzahl+1
        if instr(g((Wahl+i+1) mod (Anzahl+2)-1),ucase$(i$)) then
          Wahl=(Wahl+i+1) mod (Anzahl+2)-1: exit for
        end if
      next
  end select
loop
locate z,9
if Genre?=255 then ? g(-1); else ? g(Genre?);
for i=1 to 9: locate z+i,9: ?"            ";: next

locate z+1,1: ?"Diese nderungen abspeichern? <J/n>"	'noch eine Abfrage
i$=ucase$(input$(1))
if i$="N" or i$=chr$(27) then close: end
put$ 1,"TAG"+Titel$+Interpret$+Cd$+Jahr$+Kommentar$+chr$(Genre?)
SetFileDate Datum??, Zeit??
close: end

data"kein Genre","Blues","Classic Rock","Country","Dance","Disco","Funk","Grunge","Hip-Hop","Jazz","Metal","New Age","Oldies","Other","Pop","R&B","Rap","Reggae","Rock","Techno","Industrial","Alternative","Ska","Death Metal","Pranks"
data"Soundtrack","Euro-Techno","Ambient","Trip-Hop","Vocal","Jazz+Funk","Fusion","Trance","Classical","Instrumental","Acid","House","Game","Sound Clip","Gospel","Noise","Altern. Rock","Bass","Soul","Punk","Space","Meditative","Instrumental Pop"
data"Instrumental Rock","Ethnic","Gothic","Darkwave","Techno-Industrial","Electronic","Pop-Folk","Eurodance","Dream","Southern Rock","Comedy","Cult","Gangsta Rap","Top 40","Christian Rap","Pop/Funk","Jungle","Native American","Cabaret"
data"New Wave","Psychedelic","Rave","Showtunes","Trailer","Lo-Fi","Tribal","Acid Punk","Acid Jazz","Polka","Retro","Musical","Rock & Roll","Hard Rock","Folk","Folk/Rock","National Folk","Swing","Fast-Fusion","Bebob","Latin","Revival","Celtic"
data"Bluegrass","Avantgarde","Gothic Rock","Progressive Rock","Psychedelic Rock","Symphonic Rock","Slow Rock","Big Band","Chorus","Easy Listening","Acoustic","Humour","Speech","Chanson","Opera","Chamber Music","Sonata","Symphony","Booty Bass"
data"Primus","Porn Groove","Satire","Slow Jam","Club","Tango","Samba","Folklore","Ballad","Power Ballad","Rhythmic Soul","Freestyle","Duet","Punk Rock","Drum Solo","A Cappella","Euro-House","Dance Hall","Goa","Drum & Bass","Club-House"
data"Hardcore","Terror","Indie","BritPop","Negerpunk","Polsk Punk","Beat","Chri. Gangsta Rap","Heavy Metal","Black Metal","Crossover","Contemporary Chr.","Christian Rock","Merengue","Salsa","Thrash Metal","Anime","JPop","Synthpop"

sub Eingabe (a$, l, b$)					'Editier-Programm
  static Ansi
  ? a$;": [";space$(l);"]";
  c$=rtrim$(b$, any chr$(32,0,9,255)): p=len(c$)+1
  replace any "" with "" in c$
  do
    locate , len(a$)+4: ? c$;space$(l-len(c$));
    locate , len(a$)+3+p, 1
    i$="": while i$="": i$=inkey$: wend
    select case i$
      case chr$(0,71): p=1				'Pos1
      case chr$(0,79): p=len(c$)+1			'Ende
      case chr$(0,75): if p>1 then decr p		'Pfeil links
      case chr$(0,77): if p<len(c$)+1 then incr p	'Pfeil rechts
      case chr$(8)					'Backspace
        if p>1 then c$=left$(c$,p-2)+mid$(c$,p): decr p
      case chr$(0,83)					'Entf
        if p<=len(c$) then c$=left$(c$,p-1)+mid$(c$,p+1)
      case chr$(13)					'Enter
        if l=4 then
          if val(c$)>49 and val(c$)<100 then c$="19"+c$
          if val(c$)>0 and val(c$)<50 then c$="20"+c$
        end if
        b$=c$: exit loop
      case chr$(27)					'Esc
        exit loop
      case " " to ""					'sonstige Zeichen
        if len(c$)<l then
          c$=left$(c$,p-1)+i$+mid$(c$,p): incr p
        end if
    end select
  loop
  b$=left$(b$+space$(l),l)
  locate , len(a$)+4, 0: ? b$
  if Ansi=0 and instr(b$, any "") then
    ?"Sollen die Umlaute im Windows-Format gespeichert werden? <J/n>"
    if ucase$(input$(1))="N" then
      Ansi=1						'im DOS Format
    else
      Ansi=2						'im Windows Format
    end if
  end if
  if Ansi=2 then
    replace any "" with "" in b$
  end if
end sub

sub GetFileDate (Datum??, Zeit??)
  DosHandle=fileattr(1,2)
  ! push ds
  ! mov AX,&H5700
  ! mov BX,DosHandle
  ! int &H21
  ! mov fTime??,cx
  ! mov fDate??,dx
  ! pop DS
  Datum??=fDate??: Zeit??=fTime??
end sub

sub SetFileDate (byval fDate??, byval fTime??)
  DosHandle=fileattr(1,2)
  ! push DS
  ! mov AX,&H5701
  ! mov BX,DosHandle
  ! mov CX,fTime??
  ! mov DX,fDate??
  ! int &H21
  ! pop DS
end sub